﻿using System;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Dispatcher;

namespace TestServer
{
    /// <summary>
    /// 글로벌 에러 핸들러
    /// </summary>
    public class GlobalErrorHandler : IErrorHandler
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 에러 처리하기 - HandleError(exception)

        /// <summary>
        /// 에러 처리하기
        /// </summary>
        /// <param name="exception">예외</param>
        /// <returns>처리 여부</returns>
        public bool HandleError(Exception exception)
        {
            // 예외 처리 로그를 작성한다.

            return true;
        }

        #endregion
        #region 폴트 제공하기 - ProvideFault(exception, messageVersion, faultMessage)

        /// <summary>
        /// 폴트 제공하기
        /// </summary>
        /// <param name="exception">예외</param>
        /// <param name="messageVersion">메시지 버전</param>
        /// <param name="faultMessage">폴트 메시지</param>
        public void ProvideFault(Exception exception, MessageVersion messageVersion, ref Message faultMessage)
        {
            if(exception is FaultException)
            {
                return;
            }

            FaultException faultException = new FaultException("일반적인 서비스 오류가 발생했습니다.");

            MessageFault messageFault = faultException.CreateMessageFault();

            faultMessage = Message.CreateMessage(messageVersion, messageFault, null);
        }

        #endregion
    }
}